/* ********************************************************************************
 * Copyright 2017-2021 VMware, Inc.  All rights reserved. -- VMware Confidential
 * ********************************************************************************//**
 * content_script.js
 *
 *   Content script loaded by Chrome into every webpage.
 */var Html5MMRContentScript=Html5MMRContentScript||function(){function f(){return window.chrome!==undefined&&chrome.runtime!==undefined}function g(){function C(a){if(typeof a=="number"){var b="["+a+"]";document.title.includes(b)||(document.title=document.title.concat(b),z.info("Set window title = "+document.title))}}function D(){return window.self==window.top}function E(a){var b=document.getElementsByTagName("iframe"),c=document.getElementsByTagName("frame");for(var d=0;d<b.length;d++)if(b[d].contentWindow==a){var e=F(b[d]);if(e&&typeof e.top=="number"&&typeof e.left=="number")return e}for(var d=0;d<c.length;d++)if(c[d].contentWindow==a){var e=F(c[d]);if(e&&typeof e.top=="number"&&typeof e.left=="number")return e}return z.error("getFrameBoundingClientRect(): Error in retrieving info."),{error:!0}}function F(a,b){var c=a.getBoundingClientRect(),d=1;return typeof window.devicePixelRatio=="number"&&(d=window.devicePixelRatio),b&&b.left&&b.top?{left:c.left*d+b.left,top:c.top*d+b.top,bottom:c.bottom*d+b.top,right:c.right*d+b.left,width:c.width*d,height:c.height*d}:{left:c.left*d,top:c.top*d,bottom:c.bottom*d,right:c.right*d,width:c.width*d,height:c.height*d}}function G(a){return typeof a=="string"&&a.length>0&&a.substring(0,5)!="blob:"}function H(a){if(typeof a=="string"||typeof a=="number")return a+"px"}function I(a,b){var c;if(typeof b!="string")return c;while(a){c=Object.getOwnPropertyDescriptor(a,b);if(c!==undefined)break;a=Object.getPrototypeOf(a)}return c}function J(a){return a instanceof ArrayBuffer?a instanceof Uint8Array?a:new Uint8Array(a):null}function K(a,b){console.assert(a,b)}function N(a){var b=a.target,c=b._context;c instanceof M&&c.onVideoEvent(a)}function O(a){var b,c;a===undefined?b=document.getElementsByTagName("video"):b=a.getElementsByTagName("video");for(var d=0;d<b.length;d++){var e=b[d];q.indexOf(e)==-1&&(z.info("scanVideoElements: Found new video element."),q.push(e),c=new M(e),e._context=c,o.push(c))}}function P(a){var b;if(a instanceof MediaSource){for(var c=0;c<o.length;c++)if(!!o[c]._rawVideo&&p[o[c]._rawVideo.src]===a){b=o[c];break}return!b||(b._mediaSource=a),b}return z.error("getVideoContextFromMediaSource: Media source param is NULL."),b}function Q(){s=new B,s.init(),s.subscribe(e.GET_AND_SET_FRAME_INFO,function(a,b){b&&C(b.tabId),a.respond({title:document.title,url:document.URL})}),s.subscribe(e.GET_GLOBAL_OFFSET,function(a){if(D()){var b=E(a.source);b&&b.error!==!0?a.respond({top:b.top,left:b.left}):a.respond({error:!0})}else s.query(window.parent,e.GET_GLOBAL_OFFSET,null,function(b){if(b.error){a.respond({error:!0});return}var c=E(a.source);K(c),c&&c.error!==!0?a.respond({top:b.top+c.top,left:b.left+c.left}):a.respond({error:!0})})}),s.subscribe(d.WS_ONOPEN,function(a,b){b&&typeof b.id=="number"&&u.hasOwnProperty(b.id)&&u[b.id].onopen&&u[b.id].onopen()}),s.subscribe(d.WS_ONCLOSE,function(a,b){b&&typeof b.id=="number"&&u.hasOwnProperty(b.id)&&u[b.id].onclose&&u[b.id].onclose()}),s.subscribe(d.WS_ONERROR,function(a,b){b&&typeof b.id=="number"&&u.hasOwnProperty(b.id)&&u[b.id].onerror&&u[b.id].onerror()}),s.subscribe(d.WS_ONMESSAGE,function(a,b){b&&typeof b.id=="number"&&b.e!==undefined&&u.hasOwnProperty(b.id)&&u[b.id].onmessage&&u[b.id].onmessage(b.e)})}function R(){var a=new MutationObserver(function(a){a.forEach(function(a){if(a.type==="childList"){for(var b=0;b<a.addedNodes.length;b++){var c=a.addedNodes[b];if(c.nodeType!=Node.ELEMENT_NODE)continue;c.nodeName=="VIDEO"?O():c.children&&c.children.length&&O(c)}for(var b=0;b<a.removedNodes.length;b++){var d=a.removedNodes[b];if(d.nodeType!=Node.ELEMENT_NODE)continue;if(d.nodeName=="VIDEO")z.info("observeDOMVideoNodeChanges(): Video node removed."),z.info(d);else if(d.children&&d.children.length){var e=d.getElementsByTagName("video");for(var f=0;f<e.length;f++)z.info("observeDOMVideoNodeChanges(): Video node removed."),z.info(d)}}}})});a.observe(document,{childList:!0,subtree:!0})}function S(a){r==null?(x||(x=!0,s.query(window,d.GET_ENV_INFO,null,function(a){r=a,w.forEach(function(a){a()})})),a&&w.push(a)):a&&a()}function T(){if(!!URL.createObjectURL){var a=URL.createObjectURL;URL.createObjectURL=function(b){var c;return c=a(b),z.info("createObjectURL url = "+c),p[c]=b,O(),c}}if(!!MediaSource.prototype.addSourceBuffer){var b=MediaSource.prototype.addSourceBuffer;MediaSource.prototype.addSourceBuffer=function(a){var c=b.call(this,a);if(this.videoContext===undefined){this.videoContext=P(this);if(this.videoContext===undefined)return z.error("addSourceBuffer: No videoContext found"),c}return c._context=this.videoContext,c._id=j++,c._mimeType=a,this.videoContext.sendAddSourceBuffer(c),c}}!document.currentScript.dataset.browser||(v=document.currentScript.dataset.browser,v===g.CHROME&&navigator.userAgent.indexOf("Edg")>0&&(v=g.CHROMIUM_EDGE)),Q(),S(),O(),R(),z.debug("init(): "+document.URL)}const a={UNSET:0,NORMAL:1,RETRIEVE_INFO:2,PENDING:3,REDIR:4,REDIR_STOPPED:5},b={HTML5MMR_WEB_COMMAND_INVALID:0,HTML5MMR_WEB_COMMAND_DEFAULT:1,HTML5MMR_WEB_COMMAND_CREATEINSTANCE:2,HTML5MMR_WEB_COMMAND_CREATEINSTANCE_RESULT:3,HTML5MMR_WEB_COMMAND_DESTROYINSTANCE:4,HTML5MMR_WEB_COMMAND_VIDEO_CONTROL:5,HTML5MMR_WEB_COMMAND_UPDATE_OVERLAY:6,HTML5MMR_WEB_COMMAND_ADDSOURCE_BUFFER:7,HTML5MMR_WEB_COMMAND_STARTURL:8,HTML5MMR_WEB_COMMAND_STOPURL:9,HTML5MMR_WEB_COMMAND_SOURCEBUFFER_ABORT:10,HTMLMMR_WEB_COMMAND_FATAL_ERROR:12,HTMLMMR_WEB_COMMAND_UPDATE_TITLE:13,HTML5MMR_WEB_COMMAND_ADD_TEXT_TRACK:14,HTML5MMR_WEB_COMMAND_ADD_CUES:15,HTML5MMR_WEB_COMMAND_TEXT_TRACK_CHANGE:16},c=[b.HTML5MMR_WEB_COMMAND_UPDATE_OVERLAY,b.HTMLMMR_WEB_COMMAND_UPDATE_TITLE,b.HTML5MMR_WEB_COMMAND_ADD_TEXT_TRACK,b.HTML5MMR_WEB_COMMAND_ADD_CUES,b.HTML5MMR_WEB_COMMAND_TEXT_TRACK_CHANGE],d={INVALID:0,LOG_MESSAGE:1,GET_ENV_INFO:2,SET_BROWSER_ACTION:3,WS_NEW:4,WS_ONOPEN:5,WS_ONCLOSE:6,WS_ONMESSAGE:7,WS_ONERROR:8,WS_SEND:9,WS_CLOSE:10},e={INVALID:100,GET_AND_SET_FRAME_INFO:101,GET_GLOBAL_OFFSET:102,SET_TITLE:103},f={ERROR:0,WARN:1,INFO:2,DEBUG:3},g={CHROME:"Chrome",CHROMIUM_EDGE:"Chromium_Edge",EDGE:"Edge"},h=15,i=16;var j=0,k=0,l=0,m=1,n=0,o=[],p={},q=[],r=null,s=null,t=!1,u={},v=null,w=[],x=!1,y={position:"absolute",display:"block",visibility:"visible",opacity:"1"},z={_level:f.INFO,updateLogLevel:function(a){typeof a=="string"&&typeof f[a]=="number"&&(z._level=f[a])},error:function(a){z.log("ERROR",a)},warn:function(a){z.log("WARN",a)},info:function(a){z.log("INFO",a)},debug:function(a){z.log("DEBUG",a)},log:function(a,b){try{!!console&&f[a]<=z._level&&(typeof b=="object"?(console.log(b),s.post(window,d.LOG_MESSAGE,{level:a,message:JSON.stringify(b)},null)):(console.log(a+": "+b),s.post(window,d.LOG_MESSAGE,{level:a,message:b},null)))}catch(c){}}},A=function(a){var b=null,c=this,d=!1,e=a._rawVideo;this.createControl=null,this.removeCustomControl=null,this.togglePlayPauseIcon=null,this.originalVideoStyle=null;var f=o.indexOf(a),g=function(){c.videoContainer=document.createElement("div"),c.videoContainer.id="vmw-video-container"+f,c.videoContainer.className="vmw-video-container-style"},h=function(){c.controlsDiv=document.createElement("div"),c.controlsDiv.id="vmw-controls"+f,c.controlsDiv.className="vmw-controls-style"},i=function(){c.playPauseButton=document.createElement("button"),c.playPauseButton.id="vmw-playpause"+f,c.playPauseButton.className="vmw-video-paused vmw-button-style"},j=function(){c.slider=document.createElement("div"),c.slider.className="vmw-slider",c.progressBar=document.createElement("PROGRESS"),c.progressBar.id="vmw-progressbar"+f,c.progressBar.className="vmw-video-progress",c.progressBar.max="100",c.progressBar.value=0,c.seekBar=document.createElement("INPUT"),c.seekBar.type="range",c.seekBar.id="vmw-seekbar"+f,c.seekBar.className="vmw-video-seek",c.seekBar.value="0"},k=function(){c.muteUnmuteButton=document.createElement("button"),c.muteUnmuteButton.id="vmw-muteunmute"+f,c.muteUnmuteButton.className="vmw-video-volume vmw-button-style"},l=function(){c.volumeBar=document.createElement("INPUT"),c.volumeBar.type="range",c.volumeBar.id="vmw-volumebar"+f,c.volumeBar.className="vmw-video-volumeBar",c.volumeBar.value="1",c.volumeBar.min="0",c.volumeBar.max="1",c.volumeBar.step="0.1"},m=function(){c.fullscreenButton=document.createElement("button"),c.fullscreenButton.id="vmw-fullscreen"+f,c.fullscreenButton.className="vmw-video-fullscreen vmw-button-style"},n=function(){b.parentNode.insertBefore(c.videoContainer,b),c.videoContainer.appendChild(b),c.videoContainer.appendChild(e),c.slider.appendChild(c.progressBar),c.slider.appendChild(c.seekBar),c.controlsDiv.appendChild(c.playPauseButton),c.controlsDiv.appendChild(c.slider),c.controlsDiv.appendChild(c.muteUnmuteButton),c.controlsDiv.appendChild(c.volumeBar),c.controlsDiv.appendChild(c.fullscreenButton),b.appendChild(c.controlsDiv)};this.createControl=function(d){b=d,b.classList.add("vmw-overlayElement-style"),g(),h(),i(),j(),k(),l(),m(),n(),p(),y();if(e.autoplay){var f=e.play();f!==undefined&&f.then(function(){a.sendControl("play"),c.playPauseButton.classList.add("vmw-video-playing"),c.playPauseButton.classList.remove("vmw-video-paused")}).catch(function(a){z.warn("Error while playing: "+a)})}e.muted?(c.muteUnmuteButton.classList.add("vmw-video-mute"),c.muteUnmuteButton.classList.remove("vmw-video-volume"),c.volumeBar.value=0):(c.muteUnmuteButton.classList.add("vmw-video-volume"),c.muteUnmuteButton.classList.remove("vmw-video-mute"))};var p=function(){if(t===!1){var a=document.head||document.getElementsByTagName("head")[0],b='             .vmw-video-container-style {                    position: static;                    width: 100%;                    height: 100%;                 }                                 .vmw-controls-style {                 position: absolute;                 bottom: 0;                 left: 0;                 right: 0;                 min-height: 30px;                 opacity: 0;                 padding: 10px 5px;                 background-color: black;                 background-color: rgba(0, 0, 0, 0.75);                 z-index: 2147483647;                 white-space: nowrap;                 display:flex;                 justify-content:center;                 align-items:center;                 }                                 .vmw-overlayElement-style:hover .vmw-controls-style {                    opacity: .9;                 }                                 .vmw-button-style {                 vertical-align: middle;                 background-color: transparent;                 color: white;                 margin:0 1%;                 font-size: 1.2em;                 border:0;                 cursor: pointer;                 outline:none;                 }                                 .vmw-video-paused:before {                    content: "\\25BA";                 }                                 .vmw-video-playing:before {                    content:"\\2759\\2759";                 }                                 .vmw-video-seek, .vmw-video-volumeBar {                    border-radius: 2px;                    vertical-align: middle;                    -webkit-appearance: none;                    background-color: rgba(255, 255, 255, 0.7);                    height: 1px;                    border: none;                    cursor: pointer;                    outline:none;                 }                 .vmw-video-volumeBar {                  max-width:8%;               }                               .vmw-video-seek::-webkit-slider-thumb {                    -webkit-appearance: none;                    border-radius: 50%;                    height: 8px;                    width: 8px;                    background-color: white;                    border: 0;                 }                                 .vmw-video-volumeBar::-webkit-slider-thumb {                    -webkit-appearance: none;                    border-radius: 50%;                    height: 8px;                    width: 8px;                    background-color: white;                    border: 0;                 }                                 .vmw-slider {                    position: relative;                    width: 60%;                    z-index: 0;                    margin: 0 10px;                 }                                 .vmw-video-seek {                    z-index: 3;                    position: relative;                    width: 100%;                    background-color: transparent;                 }                                 .vmw-video-progress {                    position: absolute;                    left: 0;                    top: 50%;                    width: 100%;                    pointer-events: none;                    height: 3px;                    z-index: 2;                    appearance: none;                    -webkit-appearance: none;                    border: none;                    background: rgba(255, 255, 255, 0.1);                    color: #c0392b;                 }                                 .vmw-video-progress::-webkit-progress-bar {                    background: rgba(255, 255, 255, 0.1);                 }                                 .vmw-video-progress::-webkit-progress-value {                    background: #c0392b;                 }                                 .vmw-video-mute:before {                    content: "\\1F50A";                    opacity: 0.3;                 }                                 .vmw-video-volume:before {                    content: "\\1F50A";                 }                                 .vmw-video-volumebar {                    width: 8%;                    margin: 0 1%;                 }                                 .video-full-screen {                    left : 0px;                    top : 0px;                    position: relative;                    width: 100%;                    height: 100%;                 }                                 .vmw-video-fullscreen:before {                    content: "\\2927";                 }                 .vmw-video-fullscreen-exit:before {                    content: "\\2929";                 } ';styleNode=document.createElement("style"),styleNode.type="text/css",styleNode.appendChild(document.createTextNode(b)),a.appendChild(styleNode),t=!0}},q=function(){if(e.paused){var a=e.play();a!==undefined&&a.then(function(){c.playPauseButton.classList.add("vmw-video-playing"),c.playPauseButton.classList.remove("vmw-video-paused")}).catch(function(a){z.warn("Error while playing: "+a)})}else e.pause(),c.playPauseButton.classList.add("vmw-video-paused"),c.playPauseButton.classList.remove("vmw-video-playing")};this.togglePlayPauseIcon=function(){e.paused?(c.playPauseButton.classList.add("vmw-video-paused"),c.playPauseButton.classList.remove("vmw-video-playing")):(c.playPauseButton.classList.add("vmw-video-playing"),c.playPauseButton.classList.remove("vmw-video-paused"))};var r=function(){d?document.cancelFullScreen?(document.cancelFullScreen(),s()):document.webkitCancelFullScreen&&(document.webkitCancelFullScreen(),s()):e.requestFullscreen&&e.parentNode.requestFullscreen?(e.parentNode.requestFullscreen(),A()):e.webkitRequestFullscreen&&e.parentNode.webkitRequestFullscreen&&(e.parentNode.webkitRequestFullscreen(),A())},s=function(){document.webkitCurrentFullScreenElement||(e.classList.remove("video-full-screen"),e.parentNode.style="",e.style=c.originalVideoStyle,d=!1,c.fullscreenButton.classList.add("vmw-video-fullscreen"),c.fullscreenButton.classList.remove("vmw-video-fullscreen-exit"))},u=function(){var a=0;typeof e.currentTime=="number"&&typeof e.duration=="number"&&!isNaN(e.duration)&&(a=Math.floor(e.currentTime/e.duration*100)),c.progressBar.value=a,c.seekBar.value=a};this.toggleMuteUnmuteIcon=function(a){c.volumeBar.value=a,a==0?(c.muteUnmuteButton.classList.add("vmw-video-mute"),c.muteUnmuteButton.classList.remove("vmw-video-volume")):(c.muteUnmuteButton.classList.add("vmw-video-volume"),c.muteUnmuteButton.classList.remove("vmw-video-mute"))};var v=function(){if(e.volume===0)return;e.muted?(e.muted=!1,c.muteUnmuteButton.classList.add("vmw-video-volume"),c.muteUnmuteButton.classList.remove("vmw-video-mute")):(e.muted=!0,c.muteUnmuteButton.classList.add("vmw-video-mute"),c.muteUnmuteButton.classList.remove("vmw-video-volume"))},w=function(){e.volume=parseFloat(c.volumeBar.value);if(isNaN(e.volume)){z.warn("Failed to set volume.");return}e.volume>0&&e.muted===!0&&(e.muted=!1)},x=function(){e.pause(),e.currentTime=0,c.playPauseButton.classList.add("vmw-video-paused"),c.playPauseButton.classList.remove("vmw-video-playing")},y=function(){c.playPauseButton.addEventListener("click",q,!1),c.volumeBar.addEventListener("change",w,!1),c.muteUnmuteButton.addEventListener("click",v,!1),c.fullscreenButton.addEventListener("click",r,!1),c.seekBar.addEventListener("input",function(){if(typeof e.currentTime=="number"&&typeof e.duration=="number"&&!isNaN(e.duration)){var a=e.duration*(c.seekBar.value/100);e.currentTime=a}},!1),c.seekBar.addEventListener("mousedown",function(){e.pause()},!1),c.seekBar.addEventListener("mouseup",function(){var a=e.play();a!==undefined&&a.then(function(){c.playPauseButton.classList.remove("vmw-video-paused"),c.playPauseButton.classList.add("vmw-video-playing")}).catch(function(a){z.warn("Error while playing: "+a)})},!1),["","webkit"].forEach(function(a){e.parentNode&&e.parentNode.addEventListener(a+"fullscreenchange",s,!1)}),e.addEventListener("click",q,!1),e.addEventListener("timeupdate",u,!1),e.addEventListener("ended",x,!1)},A=function(){e.parentNode.style.height="100%",e.parentNode.style.width="100%",c.originalVideoStyle=e.getAttribute("style"),e.style="visibility: hidden",e.classList.add("video-full-screen"),d=!0,c.fullscreenButton.classList.remove("vmw-video-fullscreen"),c.fullscreenButton.classList.add("vmw-video-fullscreen-exit")};this.removeCustomControl=function(){["","webkit"].forEach(function(a){e.parentNode&&e.parentNode.removeEventListener(a+"fullscreenchange",s,!1)});while(c.videoContainer.firstChild)c.videoContainer.parentNode.insertBefore(c.videoContainer.firstChild,c.videoContainer);c.videoContainer.parentNode.removeChild(c.videoContainer),e.removeEventListener("click",q,!1),e.removeEventListener("timeupdate",u,!1),e.removeEventListener("ended",x,!1)}},B=function(){var a=this,b={},c=0,d=1e3,e=null;this.post=null,this.query=null,this.subscribe=null,this.unsubscribe=null,this.init=function(){window.addEventListener("message",e,!1)},this.subscribe=function(a,d){if(typeof d!="function")return!1;var e=(c++).toString();return b[a]===undefined&&(b[a]={subscriptions:{}}),b[a].subscriptions[e]=d,!0},this.unsubscribe=function(a,c){if(b[a]&&!!c){var d=b[a].subscriptions,e=null;for(var f in d)d.hasOwnProperty(f)&&d[f]===c&&(e=f);e!==null&&delete d[e]}},this.post=function(a,b,c,d){var e=JSON.stringify({type:b,payload:c,responseKey:d,group:"html5mmr-postmessage"});a&&a.postMessage?a.postMessage(e,"*"):z.error("PostMessageHelper.post: Invalid target or Post Message support")},this.query=function(b,c,e,f){var g=null,h=d++,i=function(b,c){a.unsubscribe(h,i),f&&typeof f=="function"&&f(c)};this.subscribe(h,i),this.post(b,c,e,h)},e=function(c){try{var d=JSON.parse(c.data);if(d.type&&d.group==="html5mmr-postmessage"){c.responseKey=d.responseKey,c.respond=function(b){return a.post(c.source,c.responseKey,b)};if(b[d.type]){var e=b[d.type].subscriptions;setTimeout(function(){for(var a in e)e.hasOwnProperty(a)&&e[a](c,d.payload)},0)}}}catch(f){}}},L=function(a){var b=this;this._websocket=null,this._id=n++,this._csWebsocketRetry=!0,this._csWebsocketEnabled=!1,this.onopen=null,this.onclose=null,this.onerror=null,this.onmessage=null,this.send=null,this.close=null,u[this._id]=this,this._websocket=new WebSocket(a),this._websocket.binaryType="arraybuffer",this._websocket.onopen=function(){b._csWebsocketRetry=!1,b.onopen&&b.onopen()},this._websocket.onclose=function(){b.onclose&&b.onclose()},this._websocket.onerror=function(){b._csWebsocketRetry?(z.info("WebSocketHelper::onerror(): Retry websocket using content script."),s.post(window,d.WS_NEW,{websocketId:b._id,url:a},null),b._csWebsocketRetry=!1,b._csWebsocketEnabled=!0):b.onerror&&b.onerror()},this._websocket.onmessage=function(a){b.onmessage&&b.onmessage(a)},this.send=function(a){if(this._csWebsocketEnabled)if(a instanceof Uint8Array)a[h]=this._id,window.postMessage(a,"*");else{var b={data:a,websocketId:this._id};s.post(window,d.WS_SEND,b,null)}else this._websocket instanceof WebSocket&&this._websocket.readyState===WebSocket.OPEN?this._websocket.send(a):z.error("WebSocketHelper::send(): Failed to send data, websocket not open: "+this._id)},this.close=function(){this._csWebsocketEnabled?s.post(window,d.WS_CLOSE,{websocketId:this._id},null):this._websocket instanceof WebSocket&&this._websocket.close()}},M=function(b){var c=this,d=["loadstart","progress","suspend","pause","abort","error","emptied","stalled","loadedmetadata","loadeddata","canplay","canplaythrough","playing","waiting","seeking","seeked","ended","durationchange","timeupdate","play","pause","seeked","ratechange","resize","volumechange"],e=["loadstart","emptied","play","pause","seeked","ratechange","encrypted"];z.info("Created new VideoContext object for video with id: "+b.id),z.info(b),this._rawVideo=b,this._mediaSource=null,this._sourceBuffers={},this._state=a.NORMAL,this._cloaked=!1,this._src=null,this._webSocket=null,this._colorKey=null,this._overlayElement=null,this._clientRect=F(b),this._pendingCommands=[],this._messageQueue=[],this._title="",this._volume=0,this._muted=!1,this._poll=null,this._rawProperties={},this._overwriteProps=!1,this._overlayElementStyle=null,this._customControl=null,this._videoContextId=l++,this._videoAttrObserver=new MutationObserver(function(a){a.forEach(function(a){c.handleVideoAttrMutation(a)})}),this._overlayAttrObserver=new MutationObserver(function(a){a.forEach(function(a){c.handleOverlayAttrMutation(a)})}),e.forEach(function(a){b.addEventListener(a,N)}),this.listenForTextTracks(),this._rawVideo.paused===!1&&(z.info("Found the video already playing. Sending play command to client"),this.sendControl("play")),G(this.getRawVideoSource())&&this.onloadMovie()};return M.prototype.handleVideoAttrMutation=function(a){z.info("For video, handle mutation for attribute: "+a.attributeName);switch(a.attributeName){case"controls":this._rawVideo.controls===!1&&this._customControl instanceof A?(z.info("Detected mutation of controls. Removing custom controls"),this._customControl.removeCustomControl(),this._customControl=null,this._overlayElement.innerHTML=""):this._rawVideo.controls===!0&&this._customControl===null&&(z.info("Detected mutation of controls. Injecting custom controls"),this._customControl=new A(this),this._customControl.createControl(this._overlayElement));break;case"style":var b=this._rawVideo.getAttribute("style");if(b===null||typeof b=="string"&&!b.includes("visibility: hidden"))this._rawVideo.style.visibility="hidden";break;case"class":this._overlayElement.className=this._rawVideo.className;break;default:z.warn("No handling needed")}},M.prototype.setOverlayStyle=function(){var a=this;this._overlayElement.style.backgroundColor=this._colorKey,this._overlayElement&&Object.keys(y).forEach(function(b){a._overlayElement.style[b]!==y[b]&&(a._overlayElement.style[b]=y[b])})},M.prototype.handleOverlayAttrMutation=function(a){z.info("For overlay, handle mutation for attribute: "+a.attributeName);var b=this;switch(a.attributeName){case"style":this.setOverlayStyle();break;case"class":this._overlayElement.className.includes(this._rawVideo.className)||(this._overlayElement.className=this._rawVideo.className),this._customControl instanceof A&&this._overlayElement.classList.contains("vmw-overlayElement-style")===!1&&(this._overlayElement.className+=" vmw-overlayElement-style");break;default:z.warn("No handling needed")}},M.prototype.getRawVideoSource=function(a){return this._rawVideo.currentSrc.length>0?this._rawVideo.currentSrc:this._rawVideo.src.length>0?this._rawVideo.src:null},M.prototype.onVideoEvent=function(a){z.info("Video event = "+a.type+" source = "+this.getRawVideoSource()+" _src = "+JSON.stringify(this._src)+" videoContextId: "+this._videoContextId);switch(a.type){case"loadstart":this.onloadMovie();break;case"emptied":this.onemptiedMovie();break;case"play":case"pause":this._customControl instanceof A&&this._customControl.togglePlayPauseIcon(),this.sendControl(a.type);break;case"seeked":this.sendControl(a.type,{currentTime:this._rawVideo.currentTime});break;case"ratechange":this.sendControl(a.type,{playbackRate:this._rawVideo.playbackRate});break;case"encrypted":this.stopRedir();break;default:}},M.prototype.onloadMovie=function(){var b=this,c=this.getRawVideoSource();this._src={name:c,id:k++};switch(this._state){case a.NORMAL:this.initWebContext();break;case a.REDIR:case a.REDIR_STOPPED:this.startRedir();break;case a.RETRIEVE_INFO:case a.PENDING:break;default:z.info("onLoadMovie: Case not handled.")}},M.prototype.onemptiedMovie=function(){z.info("onemptiedMovie(): state = "+this._state+", source = "+JSON.stringify(this._src)),this._state===a.REDIR&&this.sendStopUrl(),this.clearSourceBuffers(),this._messageQueue=this._messageQueue.filter(function(a){try{return a=JSON.parse(a),c.indexOf(a.commandId)!=-1}catch(b){return!1}}),this._src=null},M.prototype.stopRedir=function(){this.clearSourceBuffers(),this._messageQueue.splice(0,this._messageQueue.length),this.stopWebContext(),this.uncloak(),this.undoOverwriteProps(),this._state=a.NORMAL,this._src=null,this.setBrowserAction(!1)},M.prototype.setBrowserAction=function(b){var c=0,e=null;if(!b)for(c=0;c<o.length;c++){e=o[c];if(e&&(e._state===a.REDIR||e._state===a.REDIR_STOPPED)){z.info("setBrowserAction(): Cannot set to action to false."),b=!0;break}}s&&(z.info("setBrowserAction(): Set browser action = "+b),s.post(window,d.SET_BROWSER_ACTION,{redir:b},null))},M.prototype.initWebContext=function(){var b=this;this._state=a.RETRIEVE_INFO,z.info("Redirection state set to RETRIEVE_INFO"),S(function(){typeof r.port=="string"&&r.port.length>0&&typeof r.clientScript=="string"&&r.clientScript.length>0?b._state===a.RETRIEVE_INFO&&b.startWebContext():(z.error("Failed to retrieve port number or the client script."),b.stopRedir())})},M.prototype.startWebContext=function(){var c=this;if(this._state!==a.RETRIEVE_INFO||!r.port)return c.stopRedir();this._state=a.PENDING,this._webSocket=new L("wss://view-localhost:"+r.port),z.info("VideoContext set to PENDING state."),this._webSocket.onclose=function(){z.info("websocket closed, resume guest playing"),c.stopRedir()},this._webSocket.onerror=function(){z.error("websocket error, resume guest playing"),c.stopRedir()},this._webSocket.onopen=function(){z.info("websocket opened, issue createInstance."),D()?(C(r.tabId),c.sendCreateInstance(document.title,document.URL)):s.query(window.top,e.GET_AND_SET_FRAME_INFO,{tabId:r.tabId},function(a){z.info("sendCreateInstance(): top title = "+a.title+" url = "+a.url),c.sendCreateInstance(a.title,a.url)})},this._webSocket.onmessage=function(a){if(typeof a.data=="string"){var d=JSON.parse(a.data);switch(d.commandId){case b.HTML5MMR_WEB_COMMAND_CREATEINSTANCE_RESULT:d.allow=="false"?(z.info("onmessage: msg.allow = false, resume stream!"),c.stopRedir()):d.colorKey?(z.info("onmessage: msg.allow = true, start the redirection!"),c._colorKey=d.colorKey,c.startRedir()):(z.info("onmessage: msg.colorkey = undefined, resume stream!"),c.stopRedir());break;case b.HTMLMMR_WEB_COMMAND_FATAL_ERROR:z.info("onmessage: fatal error on client html: "+d.message),c.stopRedir();break;default:z.error("Unknown command recieved: "+d.command)}}else a.data instanceof ArrayBuffer?z.error("onmessage: ArrayBuffer message received which is not handled."):z.error("onmessage: Message not handled.")}},M.prototype.stopWebContext=function(){if(this._webSocket==null)return;this._webSocket.onopen=null,this._webSocket.onclose=null,this._webSocket.onmessage=null,this._webSocket.onerror=null,this._webSocket.close(),this._webSocket=null},M.prototype.startRedir=function(){this._state=a.REDIR,z.info("VideoContext set to REDIR state, colorkey = "+this._colorKey),this.setBrowserAction(!0),this.sendStartUrl(),this.flush(),this.doOverwriteProps(),this.cloak()},M.prototype.doOverwriteProps=function(){try{if(this._overwriteProps===!0)return;var a=this;this._volume=this._rawVideo.volume,this._rawVideo.volume=0,this.sendControl("volumechange",{volume:this._volume}),this._rawProperties.volume=I(this._rawVideo,"volume"),Object.defineProperty(this._rawVideo,"volume",{get:function(){return a._volume},set:function(b){if(typeof b!="number"){b=parseFloat(b);if(isNaN(b)){z.warn("Failed to set volume.");return}}if(a._volume!=b){a._volume=b,a._customControl instanceof A&&a._customControl.toggleMuteUnmuteIcon(b),a.sendControl("volumechange",{volume:b});if(a._rawVideo){var c=document.createEvent("Event");c.initEvent("volumechange",!1,!0),a._rawVideo.dispatchEvent(c)}}},configurable:!0}),this._muted=this._rawVideo.muted,this.sendControl("muted",{state:this._muted}),this._rawProperties.muted=I(this._rawVideo,"muted"),Object.defineProperty(this._rawVideo,"muted",{get:function(){return a._muted},set:function(b){typeof b!="boolean"&&(b=!!b);if(a._muted!=b){a._muted=b,a._customControl instanceof A&&(a._muted===!0?a._customControl.toggleMuteUnmuteIcon(0):a._customControl.toggleMuteUnmuteIcon(a._volume)),a.sendControl("muted",{state:b});if(a._rawVideo){var c=document.createEvent("Event");c.initEvent("volumechange",!1,!0),a._rawVideo.dispatchEvent(c)}}},configurable:!0}),this._overwriteProps=!0}catch(b){z.error("doOverwriteProps(): Exception = "+b.message),this.stopRedir()}},M.prototype.undoOverwriteProps=function(){this._rawProperties.volume!==undefined&&(Object.defineProperty(this._rawVideo,"volume",this._rawProperties.volume),this._rawVideo.volume=this._volume),this._rawProperties.muted!==undefined&&(Object.defineProperty(this._rawVideo,"muted",this._rawProperties.muted),this._rawVideo.muted=this._muted),this._overwriteProps=!1},M.prototype.flush=function(){var b=this;if(this._state!=a.REDIR)return;this._messageQueue.forEach(function(a){b._webSocket.send(a)}),this._messageQueue.splice(0,this._messageQueue.length)},M.prototype.clearSourceBuffers=function(){var a=this;Object.keys(this._sourceBuffers).forEach(function(b){a._sourceBuffers[b]instanceof SourceBuffer&&(a._sourceBuffers[b]._context instanceof M&&(z.info("Clear _context property."),a._sourceBuffers[b]._context=null),a._sourceBuffers[b]._appendBuffer&&(a._sourceBuffers[b].appendBuffer=a._sourceBuffers[b]._appendBuffer),a._sourceBuffers[b]._abort&&(a._sourceBuffers[b].abort=a._sourceBuffers[b]._abort)),delete a._sourceBuffers[b]})},M.prototype.cloak=function(){var a=this;if(this._cloaked===!0)return;if(this._colorKey==null){z.error("cloak failed without colorKey");return}if(this._overlayElement==null){this._overlayElement=document.createElement("div");if(this._overlayElement==null){K(!1);return}this._overlayElement.className=this._rawVideo.className,this.setOverlayStyle(),v==="Edge"&&(this._colorKey=this._overlayElement.style.backgroundColor),this._overlayAttrObserver.observe(this._overlayElement,{attributes:!0,attributeFilter:["style","class"]});var b=["mouseout","mouseover","mouseenter","mouseleave"];b.forEach(function(b){a._overlayElement.addEventListener(b,function(b){b.preventDefault(),b.stopImmediatePropagation();var c=new MouseEvent(b.type,b);a._rawVideo.dispatchEvent(c)})})}this._rawVideo.style.visibility="hidden",this._videoAttrObserver.observe(this._rawVideo,{attributes:!0,attributeFilter:["style","class","controls"]}),this._rawVideo.parentNode&&this._rawVideo.parentNode.insertBefore(this._overlayElement,this._rawVideo),this._rawVideo.controls===!0&&(z.info("Injecting custom controls"),this._customControl=new A(this),this._customControl.createControl(this._overlayElement)),this._poll=setInterval(function(){D()?a.updateOverlay():s.query(window.parent,e.GET_GLOBAL_OFFSET,null,function(b){b.error===!0?(z.error("_poll(): GET_GLOBAL_OFFSET error. Stopping Redirection."),a.stopRedir()):a.updateOverlay(b)}),a.checkTitleChange()},500),this._cloaked=!0},M.prototype.uncloak=function(){if(!this._cloaked)return;this._overlayElement!==null&&(this._videoAttrObserver.disconnect(),this._overlayAttrObserver.disconnect(),this._rawVideo.style.visibility="",this._overlayElement.style.display="none",this._overlayElement.remove(),this._overlayElement=
null,this._customControl instanceof A&&(this._customControl.removeCustomControl(),this._customControl=null)),clearInterval(this._poll),this._cloaked=!1},M.prototype.sendStartUrl=function(){if(this._src==null){z.error("startUrl: _src is null.");return}var a={command:"startUrl",commandId:b.HTML5MMR_WEB_COMMAND_STARTURL,id:this._src.name,videoSourceId:this._src.id,forceBinary:!0};this.sendText(a,!0)},M.prototype.sendStopUrl=function(){if(this._src==null){z.warn("stopUrl: _src is null.");return}var c={command:"stopUrl",commandId:b.HTML5MMR_WEB_COMMAND_STOPURL,id:this._src.name,videoSourceId:this._src.id,forceBinary:!0,seqNum:m++};this.sendText(c,!0),this._state=a.REDIR_STOPPED},M.prototype.sendCreateInstance=function(a,c){if(v!==g.EDGE&&v!==g.CHROME&&v!==g.CHROMIUM_EDGE)return z.error("No browser information available."),this.stopRedir();var d={command:"createInstance",commandId:b.HTML5MMR_WEB_COMMAND_CREATEINSTANCE,title:a,extensionVersion:"1.0",url:c,frameUrl:document.URL,browser:v,clientScript:r.clientScript};this._title=a,this._clientRect=F(this._rawVideo);for(var e in this._clientRect)d[e]=this._clientRect[e];this.sendText(d,!0)},M.prototype.sendAddSourceBuffer=function(a){a._appendBuffer=a.appendBuffer,a.appendBuffer=function(a){z.debug("Append buffer size = "+a.byteLength);try{this._appendBuffer(a)}catch(b){throw z.warn("appendBuffer(): Error thrown: "+b.code),b}!this._context||this._context.sendBuffer(a,this._id)},a._abort=a.abort,a.abort=function(){return!this._context||this._context.sendAbortSourceBuffer(this._id),this._abort()};var c={command:"addSourceBuffer",commandId:b.HTML5MMR_WEB_COMMAND_ADDSOURCE_BUFFER,mimeType:a._mimeType,id:a._id,forceBinary:!0};this._sourceBuffers[a._id]=a,this.sendText(c)},M.prototype.sendControl=function(a,c){var d={command:"control",commandId:b.HTML5MMR_WEB_COMMAND_VIDEO_CONTROL,control:a,param:c,seqNum:m++,forceBinary:!0};this.sendText(d)},M.prototype.checkTitleChange=function(){var a=this;D()?document.title!=this._title&&(C(r.tabId),this.sendUpdateTitle(document.title)):s.query(window.top,e.GET_AND_SET_FRAME_INFO,{tabId:r.tabId},function(b){b.title!=a._title&&a.sendUpdateTitle(b.title)})},M.prototype.sendUpdateTitle=function(a){this._title=a;var c={command:"updateTitle",commandId:b.HTMLMMR_WEB_COMMAND_UPDATE_TITLE,title:this._title};this.sendText(c)},M.prototype.updateOverlay=function(a){if(!this._overlayElement||!this._rawVideo){z.error("updateOverlay(): Invalid element references."),this.stopRedir();return}this._overlayElement.parentNode!=this._rawVideo.parentNode&&this._rawVideo.parentNode&&this._rawVideo.parentNode.insertBefore(this._overlayElement,this._rawVideo);var c=H(this._rawVideo.clientWidth);this._overlayElement.style.width!=c&&(this._overlayElement.style.width=c);var d=H(this._rawVideo.clientHeight);this._overlayElement.style.height!=d&&(this._overlayElement.style.height=d);var e=H(this._rawVideo.offsetLeft);this._overlayElement.style.left!=e&&(this._overlayElement.style.left=e);var f=H(this._rawVideo.offsetTop);this._overlayElement.style.top!=f&&(this._overlayElement.style.top=f);var g=F(this._rawVideo,a);g.right-g.left==0&&g.bottom-g.top==0&&(g=F(this._overlayElement,a));if(g.left==this._clientRect.left&&g.right==this._clientRect.right&&g.top==this._clientRect.top&&g.bottom==this._clientRect.bottom)return;this._clientRect=g;var h={command:"updateOverlay",commandId:b.HTML5MMR_WEB_COMMAND_UPDATE_OVERLAY};for(var i in g)h[i]=g[i];this.sendText(h)},M.prototype.sendBuffer=function(a,b){if(this._src===null||typeof this._src.id!="number"||typeof b!="number")return z.error("sendBuffer(): Invalid parameter to function."),this.stopRedir(),!1;var c=new Uint8Array(i);c[0]=this._src.id,c[1]=b,c[2]=0;var d=new Uint8Array(a.byteLength+i);return a instanceof ArrayBuffer&&(a=J(a)),d.set(c,0),d.set(a,i),K(d instanceof Uint8Array),this.send(d),!0},M.prototype.sendAbortSourceBuffer=function(a){var b=new Uint8Array(i);b[0]=this._src.id,b[1]=a,b[2]=1,this.send(b)},M.prototype.sendText=function(a,b){if(a==null)return;a.videoContextId=this._videoContextId,z.info(a),this.send(JSON.stringify(a),b)},M.prototype.send=function(b,c){K(b);if(c===!0){this._webSocket.send(b);return}this._state!=a.REDIR?this._messageQueue.push(b):this._webSocket.send(b)},M.prototype.listenForTextTracks=function(){var a=0,b=this;return!this._rawVideo||!this._rawVideo.textTracks?(z.error("listenForTextTracks(): Invalid raw video properties."),!1):(this._rawVideo.textTracks.onaddtrack=function(a){b.addTextTrack(a.track)},this._rawVideo.textTracks.onchange=function(a){b.textTrackChange(a)},!0)},M.prototype.addCues=function(a,c){var d=[],e=0;if(!(c instanceof TextTrackCueList))return z.info("addCues(): Invalid cues parameter"),!1;if(!(a instanceof TextTrack))return z.info("addCues(): Invalid track parameter "),!1;for(e=0;e<c.length;e++){var f={startTime:c[e].startTime,endTime:c[e].endTime,text:c[e].text};d.push(f)}var g={command:"addCues",commandId:b.HTML5MMR_WEB_COMMAND_ADD_CUES,cues:d,label:a.label,forceBinary:!0};this.sendText(g)},M.prototype.addTextTrack=function(a){var c=this,d=[],e=null,f=0;if(!!this._rawVideo&&a instanceof TextTrack){var g={command:"addTextTrack",commandId:b.HTML5MMR_WEB_COMMAND_ADD_TEXT_TRACK,kind:a.kind,label:a.label,language:a.language,mode:a.mode,id:a.id,forceBinary:!0};this.sendText(g),d=this._rawVideo.getElementsByTagName("track");for(f=0;f<d.length;f++)d[f].track==a&&(z.info("addTextTrack(): Found track element for label: "+a.label),e=d[f]);return e&&e.addEventListener("load",function h(){z.info("addTextTrack(): Track element loaded = "+this.label),c.addCues(this.track,this.track.cues),this.removeEventListener("load",h)}),!0}return z.error("addTextTrack(): Invalid TextTrack object."),!1},M.prototype.textTrackChange=function(a){var c=0;for(c=0;c<this._rawVideo.textTracks.length;c++){var d={command:"textTrackChange",commandId:b.HTML5MMR_WEB_COMMAND_TEXT_TRACK_CHANGE,label:this._rawVideo.textTracks[c].label,mode:this._rawVideo.textTracks[c].mode,forceBinary:!0};this.sendText(d)}},T(),!0}function h(){var a="("+g+")();",b=document.createElement("script");b.innerHTML=a,b.dataset.browser=f()?"Chrome":"Edge",b.onload=function(){this.parentNode.removeChild(this)},(document.head||document.documentElement).appendChild(b)}function i(a,b){var c=JSON.stringify({type:a,payload:b,responseKey:null,group:"html5mmr-postmessage"});window&&window.postMessage&&window.postMessage(c,"*")}function j(b){try{if(b.source===window){var e=JSON.parse(b.data);if(e&&e.type&&e.group==="html5mmr-postmessage")switch(e.type){case a.LOG_MESSAGE:f()&&c({type:e.type,message:e.payload.message,logLevel:e.payload.level});break;case a.SET_BROWSER_ACTION:c({type:e.type,redir:e.payload.redir});break;case a.GET_ENV_INFO:c({type:e.type,responseKey:e.responseKey},function(a){if(a.clientScript===undefined){var b=new XMLHttpRequest;b.open("GET",d("html5mmrPlayer.js"),!0),b.onreadystatechange=function(){b.readyState==XMLHttpRequest.DONE&&b.status==200&&i(e.responseKey,{port:a.port,tabId:a.tabId,clientScript:this.responseText})},b.send()}else i(e.responseKey,{port:a.port,tabId:a.tabId,clientScript:a.clientScript})})}}}catch(b){}}function k(){f()?(c=chrome.runtime.sendMessage,d=chrome.runtime.getURL):(c=browser.runtime.sendMessage,d=browser.runtime.getURL),h(),window.addEventListener("message",j,!1),new e}const a={INVALID:0,LOG_MESSAGE:1,GET_ENV_INFO:2,SET_BROWSER_ACTION:3,WS_NEW:4,WS_ONOPEN:5,WS_ONCLOSE:6,WS_ONMESSAGE:7,WS_ONERROR:8,WS_SEND:9,WS_CLOSE:10},b=15;var c=null,d=null,e=function(){var c={},d=function(d){try{if(d.source!==window)return;if(typeof d.data=="string"){var e=JSON.parse(d.data);if(e&&e.type&&e.group==="html5mmr-postmessage")switch(e.type){case a.WS_NEW:var f=e.payload.url,g=e.payload.websocketId,h=new WebSocket(f);h.onopen=function(){i(a.WS_ONOPEN,{id:g})},h.onclose=function(){i(a.WS_ONCLOSE,{id:g})},h.onerror=function(){i(a.WS_ONERROR,{id:g})},h.onmessage=function(b){b&&typeof b.data=="string"&&i(a.WS_ONMESSAGE,{id:g,e:{data:b.data}})},c[g]=h;break;case a.WS_SEND:e.payload&&e.payload.data!==undefined&&c.hasOwnProperty(e.payload.websocketId)&&(c[e.payload.websocketId]instanceof WebSocket&&c[e.payload.websocketId].readyState===WebSocket.OPEN?c[e.payload.websocketId].send(e.payload.data):Logger.error("Failed to send data, websocket not open: "+e.payload.websocketId));break;case a.WS_CLOSE:e.payload&&c.hasOwnProperty(e.payload.websocketId)&&c[e.payload.websocketId]instanceof WebSocket&&c[e.payload.websocketId].close()}}else if(d.data instanceof Uint8Array){var j=d.data[b];c.hasOwnProperty(j)&&(c[j]instanceof WebSocket&&c[j].readyState===WebSocket.OPEN?c[j].send(d.data):Logger.error("Failed to send data, websocket not open: "+j))}}catch(d){}};window.addEventListener("message",d,!1)};return k(),!0}();